<?php if (!defined('ABSPATH')) {exit;}
/**
* Plugin Name: XML for Avito
* Plugin URI: https://icopydoc.ru/category/documentation/xml-for-avito/
* Description: Подключите свой магазин к Avito чтобы увеличить продажи!
* Version: 1.5.1
* Requires at least: 4.5
* Requires PHP: 5.6
* Author: Maxim Glazunov
* Author URI: https://icopydoc.ru
* License: GPL v2 or later
* License URI: https://www.gnu.org/licenses/gpl-2.0.html
* Text Domain: xfavi
* Domain Path: /languages
* Tags: xml, avito, market, export, woocommerce
* WC requires at least: 3.0.0
* WC tested up to: 6.6.1
*
* This program is free software; you can redistribute it and/or modify it under the terms of the GNU
* General Public License version 2, as published by the Free Software Foundation. You may NOT assume
* that you can use any other version of the GPL.
*
* This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without
* even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
* 
* Copyright 2018-2022 (Author emails: djdiplomat@yandex.ru, support@icopydoc.ru)
*/ 

// Check if WooCommerce is active
$plugin = 'woocommerce/woocommerce.php';
if (!in_array($plugin, apply_filters('active_plugins', get_option('active_plugins', array()))) && !(is_multisite() && array_key_exists($plugin, get_site_option('active_sitewide_plugins', array())))) {
	add_action('admin_notices', 'xfavi_warning_notice');
	return;
}
/**
* Display a notice in the admin Plugins page if the plugin is activated while WooCommerce is deactivated.
*
* @hook admin_notices
* @since 1.4.3
*/
function xfavi_warning_notice() {
	$class = 'notice notice-error';
	$message = 'XML for Avito '. __('требуется, чтобы WooCommerce был установлен и активирован', 'xfavi');
	printf('<div class="%1$s"><p>%2$s</p></div>', $class, $message);
}
// end Check if WooCommerce is active

$upload_dir = wp_get_upload_dir();
define('XFAVI_SITE_UPLOADS_URL', $upload_dir['baseurl']); // http://site.ru/wp-content/uploads
define('XFAVI_SITE_UPLOADS_DIR_PATH', $upload_dir['basedir']); // /home/site.ru/public_html/wp-content/uploads

define('XFAVI_PLUGIN_VERSION', '1.5.1'); // 1.0.0
define('XFAVI_PLUGIN_UPLOADS_DIR_URL', $upload_dir['baseurl'].'/xml-for-avito'); // http://site.ru/wp-content/uploads/xml-for-avito
define('XFAVI_PLUGIN_UPLOADS_DIR_PATH', $upload_dir['basedir'].'/xml-for-avito'); // /home/site.ru/public_html/wp-content/uploads/xml-for-avito
define('XFAVI_PLUGIN_DIR_URL', plugin_dir_url(__FILE__)); // http://site.ru/wp-content/plugins/xml-for-avito/
define('XFAVI_PLUGIN_DIR_PATH', plugin_dir_path(__FILE__)); // /home/p135/www/site.ru/wp-content/plugins/xml-for-avito/
define('XFAVI_PLUGIN_MAIN_FILE_PATH', __FILE__); // /home/p135/www/site.ru/wp-content/plugins/xml-for-avito/xml-for-avito.php
define('XFAVI_PLUGIN_SLUG', wp_basename(dirname(__FILE__))); // xml-for-avito - псевдоним плагина
define('XFAVI_PLUGIN_BASENAME', plugin_basename(__FILE__)); // xml-for-avito/xml-for-avito.php - полный псевдоним плагина (папка плагина + имя главного файла)
unset($upload_dir);

require_once XFAVI_PLUGIN_DIR_PATH.'/packages.php';
require_once plugin_dir_path(__FILE__).'/offer.php';
require_once plugin_dir_path(__FILE__).'/ad/business.php';
require_once plugin_dir_path(__FILE__).'/ad/dom.php';
require_once plugin_dir_path(__FILE__).'/ad/hobby.php';
require_once plugin_dir_path(__FILE__).'/ad/lichnye_veshi.php';
require_once plugin_dir_path(__FILE__).'/ad/main_part.php';
require_once plugin_dir_path(__FILE__).'/ad/tehnika.php';
require_once plugin_dir_path(__FILE__).'/ad/zapchasti.php';
require_once plugin_dir_path(__FILE__).'/ad/zhivotnye.php';
register_activation_hook(__FILE__, array('XmlforAvito', 'on_activation'));
register_deactivation_hook(__FILE__, array('XmlforAvito', 'on_deactivation'));
register_uninstall_hook(__FILE__, array('XmlforAvito', 'on_uninstall'));
add_action('plugins_loaded', array('XmlforAvito', 'init'));

final class XmlforAvito {
	private $site_uploads_url = XFAVI_SITE_UPLOADS_URL; // http://site.ru/wp-content/uploads
	private $site_uploads_dir_path = XFAVI_SITE_UPLOADS_DIR_PATH; // /home/site.ru/public_html/wp-content/uploads
	private $plugin_version = XFAVI_PLUGIN_VERSION; // 1.0.0
	private $plugin_upload_dir_url = XFAVI_PLUGIN_UPLOADS_DIR_URL; // http://site.ru/wp-content/uploads/xml-for-avito/
	private $plugin_upload_dir_path = XFAVI_PLUGIN_UPLOADS_DIR_PATH; // /home/site.ru/public_html/wp-content/uploads/xml-for-avito/
	private $plugin_dir_url = XFAVI_PLUGIN_DIR_URL; // http://site.ru/wp-content/plugins/xml-for-avito/
	private $plugin_dir_path = XFAVI_PLUGIN_DIR_PATH; // /home/p135/www/site.ru/wp-content/plugins/xml-for-avito/
	private $plugin_main_file_path = XFAVI_PLUGIN_MAIN_FILE_PATH; // /home/p135/www/site.ru/wp-content/plugins/xml-for-avito/xml-for-avito.php
	private $plugin_slug = XFAVI_PLUGIN_SLUG; // xml-for-avito - псевдоним плагина
	private $plugin_basename = XFAVI_PLUGIN_BASENAME; // xml-for-avito/xml-for-avito.php - полный псевдоним плагина (папка плагина + имя главного файла)

	protected static $instance;
	public static function init() {
		if (is_null(self::$instance)) {
			self::$instance = new self();
		}
		return self::$instance;  
	}

	// Срабатывает при активации плагина (вызывается единожды)
	public static function on_activation() {
		if (!current_user_can('activate_plugins')) {return;}

		$name_dir = XFAVI_SITE_UPLOADS_DIR_PATH.'/xml-for-avito';
		if (!is_dir($name_dir)) {
			if (!mkdir($name_dir)) {
				error_log('ERROR: Ошибка создания папки '.$name_dir.'; Файл: xml-for-avito.php; Строка: '.__LINE__, 0);
			}
		}
		$feed_id = '1'; // (string)
		$name_dir = XFAVI_SITE_UPLOADS_DIR_PATH.'/xml-for-avito/feed'.$feed_id;
		if (!is_dir($name_dir)) {
			if (!mkdir($name_dir)) {
				error_log('ERROR: Ошибка создания папки '.$name_dir.'; Файл: xml-for-avito.php; Строка: '.__LINE__, 0);
			}
		}

		xfavi_optionADD('xfavi_status_sborki', '-1', $feed_id); // статус сборки файла

		$xfavi_registered_feeds_arr = array(
			0 => array('last_id' => '1'),
			1 => array('id' => '1')
		);

		$def_plugin_date_arr = new XFAVI_Data_Arr();
		$xfavi_settings_arr = array();
		$xfavi_settings_arr['1'] = $def_plugin_date_arr->get_opts_name_and_def_date('all');

		if (is_multisite()) {
			add_blog_option(get_current_blog_id(), 'xfavi_version', '1.5.1');
			add_blog_option(get_current_blog_id(), 'xfavi_keeplogs', '');
			add_blog_option(get_current_blog_id(), 'xfavi_disable_notices', '');
			add_blog_option(get_current_blog_id(), 'xfavi_enable_five_min', '');
			add_blog_option(get_current_blog_id(), 'xfavi_feed_content', '');

			add_blog_option(get_current_blog_id(), 'xfavi_settings_arr', $xfavi_settings_arr);
			add_blog_option(get_current_blog_id(), 'xfavi_registered_feeds_arr', $xfavi_registered_feeds_arr);
		} else {
			add_option('xfavi_version', '1.5.1');
			add_option('xfavi_keeplogs', '');
			add_option('xfavi_disable_notices', '');
			add_option('xfavi_enable_five_min', '');
			add_option('xfavi_feed_content', '');

			add_option('xfavi_settings_arr', $xfavi_settings_arr);
			add_option('xfavi_registered_feeds_arr', $xfavi_registered_feeds_arr);
		}
	}
 
	// Срабатывает при отключении плагина (вызывается единожды)
	public static function on_deactivation() {
		if (!current_user_can('activate_plugins')) {return;}

		$xfavi_registered_feeds_arr = xfavi_optionGET('xfavi_registered_feeds_arr');
		for ($i = 1; $i < count($xfavi_registered_feeds_arr); $i++) { // с единицы, т.к инфа по конкретным фидам там
			$feed_id = $xfavi_registered_feeds_arr[$i]['id'];
			wp_clear_scheduled_hook('xfavi_cron_period', array($feed_id)); // отключаем крон
			wp_clear_scheduled_hook('xfavi_cron_sborki', array($feed_id)); // отключаем крон
		}
		deactivate_plugins('xml-for-avito-pro/xml-for-avito-pro.php');
	}

	public function __construct() { 
		load_plugin_textdomain('xfavi', false, $this->plugin_slug.'/languages/'); // load translation
		// $this->check_and_fix(); // если вдруг нет настроек плагина
		$this->check_options_upd(); // проверим, нужны ли обновления опций плагина
		$this->init_classes();
		$this->init_hooks(); // подключим хуки
	}

	public function check_and_fix() {
		$xfavi_settings_arr = xfavi_optionGET('xfavi_settings_arr');
		if (!is_array($xfavi_settings_arr)) {
			self::on_activation();
		}
	}

	public function init_classes() {
		return;
	}
 
	public function check_options_upd() {
		$plugin_version = $this->get_plugin_version();
		if ($plugin_version == false) { // вероятно, у нас первичная установка плагина
			if (is_multisite()) {
				update_blog_option(get_current_blog_id(), 'xfavi_version', XFAVI_PLUGIN_VERSION);
			} else {
				update_option('xfavi_version', XFAVI_PLUGIN_VERSION);
			}
		} else if ($plugin_version !== $this->plugin_version) { 
			add_action('init', array($this, 'set_new_options'), 10); // автообновим настройки, если нужно
		}
	}

	public function set_new_options() { 
		// Если предыдущая версия плагина меньше 1.5.1
		if (version_compare($this->get_plugin_version(), '1.5.1', '<')) { 
			// переход со старой версии на новую
			$xfavi_settings_arr = xfavi_optionGET('xfavi_settings_arr');
			if ($xfavi_settings_arr == false) {
				$feed_id = '1';
				for ($i = 0; $i<3; $i++) {
					$isset_plugin_date_arr = array();
					$isset_plugin_date_arr['xfavi_status_cron'] = xfavi_optionGET('xfavi_status_cron', $feed_id);
					$isset_plugin_date_arr['xfavi_step_export'] = xfavi_optionGET('xfavi_step_export', $feed_id);
				//	xfavi_optionGET('xfavi_status_sborki', $feed_id);
					$isset_plugin_date_arr['xfavi_date_sborki'] = xfavi_optionGET('xfavi_date_sborki', $feed_id);
					$isset_plugin_date_arr['xfavi_type_sborki'] = xfavi_optionGET('xfavi_type_sborki', $feed_id);
					$isset_plugin_date_arr['xfavi_file_url'] = xfavi_optionGET('xfavi_file_url', $feed_id);
					$isset_plugin_date_arr['xfavi_file_file'] = xfavi_optionGET('xfavi_file_file', $feed_id);
					$isset_plugin_date_arr['xfavi_file_ids_in_xml'] = xfavi_optionGET('xfavi_file_ids_in_xml', $feed_id);
					$isset_plugin_date_arr['xfavi_magazin_type'] = xfavi_optionGET('xfavi_magazin_type', $feed_id);
					$isset_plugin_date_arr['xfavi_date_save_set'] = xfavi_optionGET('xfavi_date_save_set', $feed_id);
					$isset_plugin_date_arr['xfavi_errors'] = xfavi_optionGET('xfavi_errors', $feed_id);
				
					$isset_plugin_date_arr['xfavi_run_cron'] = xfavi_optionGET('xfavi_run_cron', $feed_id);
					$isset_plugin_date_arr['xfavi_ufup'] = xfavi_optionGET('xfavi_ufup', $feed_id);
					$isset_plugin_date_arr['xfavi_feed_assignment'] = xfavi_optionGET('xfavi_feed_assignment', $feed_id);
					$isset_plugin_date_arr['xfavi_whot_export'] = xfavi_optionGET('xfavi_whot_export', $feed_id); 
					$isset_plugin_date_arr['xfavi_desc'] = xfavi_optionGET('xfavi_desc', $feed_id);
					$isset_plugin_date_arr['xfavi_the_content'] = xfavi_optionGET('xfavi_the_content', $feed_id);
					$isset_plugin_date_arr['xfavi_behavior_strip_symbol'] = xfavi_optionGET('xfavi_behavior_strip_symbol', $feed_id);
					$isset_plugin_date_arr['xfavi_var_desc_priority'] = xfavi_optionGET('xfavi_var_desc_priority', $feed_id);
					$isset_plugin_date_arr['xfavi_allowEmail'] = xfavi_optionGET('xfavi_allowEmail', $feed_id);
					$isset_plugin_date_arr['xfavi_managerName'] = xfavi_optionGET('xfavi_managerName', $feed_id);
					$isset_plugin_date_arr['xfavi_contactPhone'] = xfavi_optionGET('xfavi_contactPhone', $feed_id);
					$isset_plugin_date_arr['xfavi_address'] = xfavi_optionGET('xfavi_address', $feed_id);
			
					$isset_plugin_date_arr['xfavi_main_product'] = xfavi_optionGET('xfavi_main_product', $feed_id);
					$isset_plugin_date_arr['xfavi_no_default_png_products'] = xfavi_optionGET('xfavi_no_default_png_products', $feed_id);
					$isset_plugin_date_arr['xfavi_skip_products_without_pic'] = xfavi_optionGET('xfavi_skip_products_without_pic', $feed_id);
					$isset_plugin_date_arr['xfavi_skip_missing_products'] = xfavi_optionGET('xfavi_skip_missing_products', $feed_id);
					$isset_plugin_date_arr['xfavi_skip_backorders_products'] = xfavi_optionGET('xfavi_skip_backorders_products', $feed_id);
					$isset_plugin_date_arr['xfavi_size'] = xfavi_optionGET('xfavi_size', $feed_id);
					$isset_plugin_date_arr['xfavi_condition'] = xfavi_optionGET('xfavi_condition', $feed_id);
					$xfavi_settings_arr[$feed_id] = $isset_plugin_date_arr;
					$feed_id++;
				}
				$xfavi_registered_feeds_arr = array(
					0 => array('last_id' => '3'),
					1 => array('id' => '1'),
					2 => array('id' => '2'),
					3 => array('id' => '3'),
				);
				if (is_multisite()) {
					update_blog_option(get_current_blog_id(), 'xfavi_settings_arr', $xfavi_settings_arr);
					update_blog_option(get_current_blog_id(), 'xfavi_registered_feeds_arr', $xfavi_registered_feeds_arr);
				} else {
					update_option('xfavi_settings_arr', $xfavi_settings_arr);
					update_option('xfavi_registered_feeds_arr', $xfavi_registered_feeds_arr);
				}
			}
			// end переход со старой версии на новую
		}

		$xfavi_data_arr_obj = new XFAVI_Data_Arr();
		$opts_arr = $xfavi_data_arr_obj->get_opts_name_and_def_date_obj('all'); // список дефолтных настроек
		// проверим, заданы ли дефолтные настройки
		$xfavi_settings_arr = xfavi_optionGET('xfavi_settings_arr');
		$xfavi_settings_arr_keys_arr = array_keys($xfavi_settings_arr);
		for ($i = 0; $i < count($xfavi_settings_arr_keys_arr); $i++) {
			$feed_id = (string)$xfavi_settings_arr_keys_arr[$i];
			for ($n = 0; $n < count($opts_arr); $n++) {
				$name = $opts_arr[$n]->get_name();
				$value = $opts_arr[$n]->get_value();	
				if (!isset($xfavi_settings_arr[$feed_id][$name])) {xfavi_optionUPD($name, $value, $feed_id, 'yes', 'set_arr');}
			}
		}

		if (is_multisite()) {
			update_blog_option(get_current_blog_id(), 'xfavi_version', XFAVI_PLUGIN_VERSION);
		} else {
			update_option('xfavi_version', XFAVI_PLUGIN_VERSION);
		}
	}

	public function get_plugin_version() {
		if (is_multisite()) {
			$v = get_blog_option(get_current_blog_id(), 'xfavi_version');
		} else {
			$v = get_option('xfavi_version');
		}
		return $v;
	}

	public function init_hooks() {
		add_action('admin_init', array($this, 'listen_submits_func'), 10); // ещё можно слушать чуть раньше на wp_loaded
		add_action('admin_menu', array($this, 'add_admin_menu_func'));
 
		add_filter('upload_mimes', array($this, 'add_mime_types_func'), 99, 1); // чутка позже остальных
		add_filter('cron_schedules', array($this, 'add_cron_intervals_func'), 10, 1);

		add_action('xfavi_cron_sborki', array($this, 'xfavi_do_this_seventy_sec'), 10, 1);
		add_action('xfavi_cron_period', array($this, 'xfavi_do_this_event'), 10, 1);
			
		// индивидуальные опции доставки товара
		// add_action('add_meta_boxes', array($this, 'xfavi_add_custom_box'));
		add_action('save_post', array($this, 'xfavi_save_post_product_function'), 50, 3);
		// пришлось юзать save_post вместо save_post_product ибо wc блочит обновы

		// https://wpruse.ru/woocommerce/custom-fields-in-products/
		// https://wpruse.ru/woocommerce/custom-fields-in-variations/
		add_filter('woocommerce_product_data_tabs', array($this, 'xfavi_added_wc_tabs'), 10, 1);
		add_action('admin_footer', array($this, 'xfavi_art_added_tabs_icon'), 10, 1);
		add_action('woocommerce_product_data_panels', array($this, 'xfavi_art_added_tabs_panel'), 10, 1);
		add_action('woocommerce_process_product_meta',  array($this, 'xfavi_art_woo_custom_fields_save'), 10, 1);
		
		/* Мета-поля для категорий товаров */
		add_action("product_cat_edit_form_fields", array($this, 'xfavi_add_meta_product_cat'), 10, 1);
		add_action('edited_product_cat', array($this, 'xfavi_save_meta_product_cat'), 10, 1); 
		add_action('create_product_cat', array($this, 'xfavi_save_meta_product_cat'), 10, 1);
		
		add_action('admin_notices', array($this, 'xfavi_admin_notices_function'), 10, 1);
		add_action('admin_enqueue_scripts', array(&$this, 'xfavi_reg_script')); // правильно регаем скрипты в админку

		add_action('admin_notices', array($this, 'print_admin_notices_func'), 10, 1);

		/* Регаем стили только для страницы настроек плагина */
		add_action('admin_init', function() {
			wp_register_style('xfavi-admin-css', plugins_url('css/xfavi_style.css', __FILE__));
		}, 9999);

		add_filter('xfavip_args_filter', array($this, 'xfavi_args_filter_func'), 10, 3);
	}

	public function listen_submits_func() {
		do_action('xfavi_listen_submits');

		if (isset($_REQUEST['xfavi_submit_action'])) {
			$message = __('Обновлено', 'xfavi');
			$class = 'notice-success';
			if (isset($_POST['xfavi_run_cron']) && sanitize_text_field($_POST['xfavi_run_cron']) !== 'off') {
				$message .= '. '. __('Создание XML-фида запущено. Вы можете продолжить работу с сайтом', 'xfavi');
			}
					
			add_action('admin_notices', function() use ($message, $class) { 
				$this->admin_notices_func($message, $class);
			}, 10, 2);
		}
	}

 public static function xfavi_args_filter_func($args, $order_id, $order_email) {
	$xfavi_version = xfavi_optionGET('xfavi_version', 'set_arr');
	$args['basic_version'] = $xfavi_version;
	return $args;
 }

 public function xfavi_reg_script() {
	// правильно регаем скрипты в админку через промежуточную функцию
	wp_enqueue_script('xfavi_find_products', plugin_dir_url(__FILE__) . 'js/jquery.chained.min.js', array('jquery'));
 }

 public static function xfavi_admin_css_func() {
	/* Ставим css-файл в очередь на вывод */
	wp_enqueue_style('xfavi-admin-css');
 } 

 public static function xfavi_admin_head_css_func() {
	/* печатаем css в шапке админки */
	print '<style>/* XML for Avito */
		.metabox-holder .postbox-container .empty-container {height: auto !important;}
		.icp_img1 {background-image: url('. XFAVI_PLUGIN_DIR_URL .'/img/sl1.jpg);}
		.icp_img2 {background-image: url('. XFAVI_PLUGIN_DIR_URL .'/img/sl2.jpg);}
		.icp_img3 {background-image: url('. XFAVI_PLUGIN_DIR_URL .'/img/sl3.jpg);}
		.icp_img4 {background-image: url('. XFAVI_PLUGIN_DIR_URL .'/img/sl4.jpg);}
		.icp_img5 {background-image: url('. XFAVI_PLUGIN_DIR_URL .'/img/sl6.jpg);}
		.icp_img6 {background-image: url('. XFAVI_PLUGIN_DIR_URL .'/img/sl7.jpg);}
		.icp_img7 {background-image: url('. XFAVI_PLUGIN_DIR_URL .'/img/sl7.jpg);}
	</style>';
 }

	// Добавляем пункты меню
	public function add_admin_menu_func() {
		$page_suffix = add_menu_page(null , __('Экспорт на Avito', 'xfavi'), 'manage_options', 'xfaviexport', array($this, 'get_export_page_func'), 'dashicons-redo', 51);

		// создаём хук, чтобы стили выводились только на странице настроек
		add_action('admin_print_styles-'. $page_suffix, array($this, 'xfavi_admin_css_func'));
		add_action('admin_print_styles-'. $page_suffix, array($this, 'xfavi_admin_head_css_func'));

		add_submenu_page('xfaviexport', __('Отладка', 'xfavi'), __('Страница отладки', 'xfavi'), 'manage_options', 'xfavidebug', 'xfavi_debug_page');
		require_once XFAVI_PLUGIN_DIR_PATH.'/debug.php';
		
		$page_subsuffix = add_submenu_page('xfaviexport', __('Добавить расширение', 'xfavi'), __('Расширения', 'xfavi'), 'manage_options', 'xfaviextensions', 'xfavi_extensions_page');
		require_once XFAVI_PLUGIN_DIR_PATH.'/extensions.php';
		add_action('admin_print_styles-'. $page_subsuffix, array($this, 'xfavi_admin_css_func'));
	} 
 
	// вывод страницы настроек плагина
	public function get_export_page_func() {
		new XFAVI_Settings_Page();
		return;
	}
 
	// Разрешим загрузку xml и csv файлов
	public function add_mime_types_func($mimes) {
		$mimes ['csv'] = 'text/csv';
		$mimes ['xml'] = 'text/xml';
		return $mimes;
	}  

	/* добавляем интервалы крон в 70 секунд и 6 часов */
	public function add_cron_intervals_func($schedules) {
		$schedules['seventy_sec'] = array(
			'interval' => 70,
			'display' => '70 sec'
		);
		$schedules['five_min'] = array(
			'interval' => 300,
			'display' => '5 min'
		);
		$schedules['six_hours'] = array(
			'interval' => 21600,
			'display' => '6 hours'
		);
		$schedules['week'] = array(
			'interval' => 604800,
			'display' => '1 week'
		);
		return $schedules;
	}
	/* end добавляем интервалы крон в 70 секунд и 6 часов */ 
 
	// Сохраняем данные блока, когда пост сохраняется
	function xfavi_save_post_product_function ($post_id, $post, $update) {
		new XFAVI_Error_Log('Стартовала функция xfavi_save_post_product_function! Файл: xml-for-avito.php; Строка: '.__LINE__);
		
		if ($post->post_type !== 'product') {return;} // если это не товар вукомерц
		if (wp_is_post_revision($post_id)) {return;} // если это ревизия
		// проверяем nonce нашей страницы, потому что save_post может быть вызван с другого места.
		// если это автосохранение ничего не делаем
		if (defined('DOING_AUTOSAVE') && DOING_AUTOSAVE) {return;}
		// проверяем права юзера
		if (!current_user_can('edit_post', $post_id)) {return;}
		// Все ОК. Теперь, нужно найти и сохранить данные
		// Очищаем значение поля input.
		new XFAVI_Error_Log('Работает функция xfavi_save_post_product_function! Файл: xml-for-avito.php; Строка: '.__LINE__);

		// Убедимся что поле установлено.
		if (isset($_POST['_xfavi_condition'])) {
			$xfavi_condition = sanitize_text_field($_POST['_xfavi_condition']);
			$xfavi_adType = sanitize_text_field($_POST['_xfavi_adType']);
			$xfavi_goods_type = sanitize_text_field($_POST['_xfavi_goods_type']);
			$xfavi_goods_subtype = sanitize_text_field($_POST['_xfavi_goods_subtype']);
			$xfavi_apparel = sanitize_text_field($_POST['_xfavi_apparel']);
			$xfavi_appareltype = sanitize_text_field($_POST['_xfavi_appareltype']);
				
			// Обновляем данные в базе данных
			update_post_meta($post_id, '_xfavi_condition', $xfavi_condition);
			update_post_meta($post_id, '_xfavi_adType', $xfavi_adType);
			update_post_meta($post_id, '_xfavi_goods_type', $xfavi_goods_type);
			update_post_meta($post_id, '_xfavi_goods_subtype', $xfavi_goods_subtype);
			update_post_meta($post_id, '_xfavi_apparel', $xfavi_apparel);
			update_post_meta($post_id, '_xfavi_appareltype', $xfavi_appareltype);			
		}
		
		// нужно ли запускать обновление фида при перезаписи файла
		$xfavi_settings_arr = xfavi_optionGET('xfavi_settings_arr');
		$xfavi_settings_arr_keys_arr = array_keys($xfavi_settings_arr);
		for ($i = 0; $i < count($xfavi_settings_arr_keys_arr); $i++) {
			$feed_id = $xfavi_settings_arr_keys_arr[$i];

			new XFAVI_Error_Log('FEED № '.$feed_id.'; Шаг $i = '.$i.' цикла по формированию кэша файлов; Файл: xml-for-avito.php; Строка: '.__LINE__);

			$result_xml_unit = xfavi_unit($post_id, $feed_id); // формируем фид товара
			if (is_array($result_xml_unit)) {
				$result_xml = $result_xml_unit[0];
				$ids_in_xml = $result_xml_unit[1];
			} else {
				$result_xml = $result_xml_unit;
				$ids_in_xml = '';
			}
			xfavi_wf($result_xml, $post_id, $feed_id, $ids_in_xml); // записываем кэш-файл

			$xfavi_ufup = xfavi_optionGET('xfavi_ufup', $feed_id, 'set_arr');
			if ($xfavi_ufup !== 'on') {continue; /*return;*/}
			$status_sborki = (int)xfavi_optionGET('xfavi_status_sborki', $feed_id);
			if ($status_sborki > -1) {continue; /*return;*/} // если идет сборка фида - пропуск
			
			$xfavi_date_save_set = xfavi_optionGET('xfavi_date_save_set', $feed_id, 'set_arr');
			$xfavi_date_sborki = xfavi_optionGET('xfavi_date_sborki', $feed_id, 'set_arr');

			if ($feed_id === '1') {$prefFeed = '';} else {$prefFeed = $feed_id;}
			if (is_multisite()) {
				/*
				*	wp_get_upload_dir();
				*   'path'    => '/home/site.ru/public_html/wp-content/uploads/2016/04',
				*	'url'     => 'http://site.ru/wp-content/uploads/2016/04',
				*	'subdir'  => '/2016/04',
				*	'basedir' => '/home/site.ru/public_html/wp-content/uploads',
				*	'baseurl' => 'http://site.ru/wp-content/uploads',
				*	'error'   => false,
				*/
				$upload_dir = (object)wp_get_upload_dir();
				$filenamefeed = $upload_dir->basedir."/xml-for-avito/".$prefFeed."feed-avito-".get_current_blog_id().".xml";
			} else {
				$upload_dir = (object)wp_get_upload_dir();
				$filenamefeed = $upload_dir->basedir."/xml-for-avito/".$prefFeed."feed-avito-0.xml";
			}
			if (!file_exists($filenamefeed)) {
				new XFAVI_Error_Log('FEED № '.$feed_id.'; WARNING: Файла filenamefeed = '.$filenamefeed.' не существует! Пропускаем быструю сборку; Файл: xml-for-avito.php; Строка: '.__LINE__);
				continue; /*return;*/ 
			} // файла с фидом нет
			
			clearstatcache(); // очищаем кэш дат файлов
			$last_upd_file = filemtime($filenamefeed);
			new XFAVI_Error_Log('FEED № '.$feed_id.'; $xfavi_date_save_set='.$xfavi_date_save_set.';$filenamefeed='.$filenamefeed, 0);
			new XFAVI_Error_Log('FEED № '.$feed_id.'; Начинаем сравнивать даты! Файл: xml-for-avito.php; Строка: '.__LINE__);	
			if ($xfavi_date_save_set > $last_upd_file) {
				// настройки фида сохранялись позже, чем создан фид		
				// нужно полностью пересобрать фид
				new XFAVI_Error_Log('FEED № '.$feed_id.'; NOTICE: Настройки фида сохранялись позже, чем создан фид; Файл: xml-for-avito.php; Строка: '.__LINE__);
				$xfavi_status_cron = xfavi_optionGET('xfavi_status_cron', $feed_id, 'set_arr');
				$recurrence = $xfavi_status_cron;
				wp_clear_scheduled_hook('xfavi_cron_period', array($feed_id));
				wp_schedule_event(time(), $recurrence, 'xfavi_cron_period', array($feed_id));
				new XFAVI_Error_Log('FEED № '.$feed_id.'; xfavi_cron_period внесен в список заданий! Файл: xml-for-avito.php; Строка: '.__LINE__);
			} else { // нужно лишь обновить цены	
				new XFAVI_Error_Log('FEED № '.$feed_id.'; NOTICE: Настройки фида сохранялись раньше, чем создан фид. Нужно лишь обновить цены; Файл: xml-for-avito.php; Строка: '.__LINE__);
				xfavi_clear_file_ids_in_xml($feed_id); /* С версии 3.1.0 */
				xfavi_onlygluing($feed_id);
			}		
		}
		return;
	}
  
	/* функции крона */
	public function xfavi_do_this_seventy_sec($feed_id = '1') {
		new XFAVI_Error_Log('FEED № '.$feed_id.'; Крон xfavi_do_this_seventy_sec запущен; Файл: xml-for-avito.php; Строка: '.__LINE__);	 
		// xfavi_optionGET('xfavi_status_sborki', $feed_id, 'set_arr');	
		$this->xfavi_construct_xml($feed_id); // делаем что-либо каждые 70 сек
	}
	public function xfavi_do_this_event($feed_id = '1') {
		new XFAVI_Error_Log('FEED № '.$feed_id.'; Крон xfavi_do_this_event включен. Делаем что-то каждый час; Файл: xml-for-avito.php; Строка: '.__LINE__);
		$step_export = (int)xfavi_optionGET('xfavi_step_export', $feed_id, 'set_arr');
		if ($step_export === 0) {$step_export = 500;}		
		xfavi_optionUPD('xfavi_status_sborki', $step_export, $feed_id);

		wp_clear_scheduled_hook('xfavi_cron_sborki', array($feed_id));

		// Возвращает nul/false. null когда планирование завершено. false в случае неудачи.
		$res = wp_schedule_event(time(), 'seventy_sec', 'xfavi_cron_sborki', array($feed_id));
		if ($res === false) {
			new XFAVI_Error_Log('FEED № '.$feed_id.'; ERROR: Не удалось запланировань CRON seventy_sec; Файл: xml-for-avito.php; Строка: '.__LINE__);
		} else {
			new XFAVI_Error_Log('FEED № '.$feed_id.'; CRON seventy_sec успешно запланирован; Файл: xml-for-avito.php; Строка: '.__LINE__);
		}
	}
	/* end функции крона */

	public static function xfavi_added_wc_tabs($tabs) {
		$tabs['xfavi_special_panel'] = array(
			'label' => __('Avito', 'xfavi'), // название вкладки
			'target' => 'xfavi_added_wc_tabs', // идентификатор вкладки
			'class' => array('hide_if_grouped'), // классы управления видимостью вкладки в зависимости от типа товара
			'priority' => 70, // приоритет вывода
		);
		return $tabs;
	}

 public static function xfavi_art_added_tabs_icon() { 
	// https://rawgit.com/woothemes/woocommerce-icons/master/demo.html 
	?>
	<style>
		#woocommerce-coupon-data ul.wc-tabs li.xfavi_special_panel_options a::before,
		#woocommerce-product-data ul.wc-tabs li.xfavi_special_panel_options a::before,
		.woocommerce ul.wc-tabs li.xfavi_special_panel_options a::before {
			font-family: WooCommerce;
			content: "\e014";
		}
	</style>
	<?php
 }

 public static function xfavi_art_added_tabs_panel() {
	global $post; ?>
	<div id="xfavi_added_wc_tabs" class="panel woocommerce_options_panel">
		<?php do_action('xfavi_before_options_group', $post); ?>
		<div class="options_group">
			<h2><strong><?php _e('Индивидуальные настройки товара для XML фида для Avito', 'xfavi'); ?></strong></h2>
			<?php do_action('xfavi_prepend_options_group', $post); ?>
			<?php			
			woocommerce_wp_select(array(
				'id' => '_xfavi_condition',
				'label' => __('Состояние товара', 'xfavi'),
				'placeholder' => '1',
				'description' => __('Обязательный элемент', 'xfavi'). ' <strong>Condition</strong>',				
				'options' => array(
					'new' => __('Новый', 'xfavi'),
					'bu' => __('Б/у', 'xfavi'),
				),
			));		 
			woocommerce_wp_select(array(
				'id' => '_xfavi_adType',
				'label' => __('AdType', 'xfavi'),
				'placeholder' => '1',
				'description' => __('Обязателен для форматов "Для дома и дачи" и "Личные вещи"', 'xfavi'),					
				'options' => array(
					'default' => __('По умолчанию', 'xfavi'),
					'disabled' => __('Отключено', 'xfavi'),
					'Товар приобретен на продажу' => __('Товар приобретен на продажу', 'xfavi'),
					'Товар от производителя' => __('Товар от производителя', 'xfavi'),
				),
			)); ?>
			<p class="form-field _xfavi_goods_type">
				<label for="xfavi_goods_type"><?php _e('Тип товара', 'xfavi'); ?></label><select name="_xfavi_goods_type" id="_xfavi_goods_type" class="select short">
			 	<?php $xfavi_goods_type = esc_attr(get_post_meta($post->ID, '_xfavi_goods_type', 1)); ?>
			 	<option value="default" <?php selected($xfavi_goods_type, 'default'); ?>><?php _e('По умолчанию', 'xfavi'); ?></option>
				<option value="disabled" <?php selected($xfavi_goods_type, 'disabled'); ?>><?php _e('Отключено', 'xfavi'); ?></option>
				<?php echo xfavi_option_construct_product($post);
				
				/*xfavi_category_goods_type(2, $xfavi_goods_type);*/ ?>	
				</select><span class="description"><?php _e('Элемент', 'xfavi'); ?> <strong>GoodsType</strong> / <strong>Breed</strong> / <strong>TypeId</strong> / <strong>VehicleType</strong>. <a href="//autoload.avito.ru/format/" target="_blank"><?php _e('Подробнее', 'xfavi'); ?></a></span>
			</p>
			<p class="form-field _xfavi_goods_subtype">
				<label for="xfavi_goods_subtype"><?php _e('Тип товара', 'xfavi'); ?></label><select name="_xfavi_goods_subtype" id="_xfavi_goods_subtype" class="select short">
			 	<?php $xfavi_goods_subtype = esc_attr(get_post_meta($post->ID, '_xfavi_goods_subtype', 1)); ?>
			 	<option value="default" <?php selected($xfavi_goods_subtype, 'default'); ?>><?php _e('По умолчанию', 'xfavi'); ?></option>
				<option value="Изоляция" <?php selected($xfavi_goods_subtype, 'Изоляция'); ?>><?php _e('Изоляция', 'xfavi'); ?></option>
				<option value="Кровля и водосток" <?php selected($xfavi_goods_subtype, 'Кровля и водосток'); ?>><?php _e('Кровля и водосток', 'xfavi'); ?></option>
				<option value="Лаки и краски" <?php selected($xfavi_goods_subtype, 'Лаки и краски'); ?>><?php _e('Лаки и краски', 'xfavi'); ?></option>
				<option value="Листовые материалы" <?php selected($xfavi_goods_subtype, 'Листовые материалы'); ?>><?php _e('Листовые материалы', 'xfavi'); ?></option>
				<option value="Металлопрокат" <?php selected($xfavi_goods_subtype, 'Металлопрокат'); ?>><?php _e('Металлопрокат', 'xfavi'); ?></option>
				<option value="Общестроительные материалы" <?php selected($xfavi_goods_subtype, 'Общестроительные материалы'); ?>><?php _e('Общестроительные материалы', 'xfavi'); ?></option>
				<option value="Отделка" <?php selected($xfavi_goods_subtype, 'Отделка'); ?>><?php _e('Отделка', 'xfavi'); ?></option>
				<option value="Пиломатериалы" <?php selected($xfavi_goods_subtype, 'Пиломатериалы'); ?>><?php _e('Пиломатериалы', 'xfavi'); ?></option>
				<option value="Строительные смеси" <?php selected($xfavi_goods_subtype, 'Строительные смеси'); ?>><?php _e('Строительные смеси', 'xfavi'); ?></option>
				<option value="Строительство стен" <?php selected($xfavi_goods_subtype, 'Строительство стен'); ?>><?php _e('Строительство стен', 'xfavi'); ?></option>
				<option value="Электрика" <?php selected($xfavi_goods_subtype, 'Электрика'); ?>><?php _e('Электрика', 'xfavi'); ?></option>
				<option value="Другое" <?php selected($xfavi_goods_subtype, 'Другое'); ?>><?php _e('Другое', 'xfavi'); ?></option>		 	
				</select><span class="description"><?php _e('Элемент', 'xfavi'); ?> <strong>GoodsSubType</strong>. <a href="//autoload.avito.ru/format/" target="_blank"><?php _e('Подробнее', 'xfavi'); ?></a></span>
			</p>
			<p class="form-field _xfavi_apparel">
				<label for="_xfavi_apparel">Apparel</label><select name="_xfavi_apparel" id="_xfavi_apparel" class="select short" >
				<?php $xfavi_apparel = esc_attr(get_post_meta($post->ID, '_xfavi_apparel', 1)); ?>
				<option value="default" <?php selected($xfavi_apparel, 'default'); ?>><?php _e('По умолчанию', 'xfavi'); ?></option>
			 	<option value="disabled" <?php selected($xfavi_apparel, 'disabled'); ?>><?php _e('Отключено', 'xfavi'); ?></option>
				<?php echo xfavi_category_goods_type(3, $xfavi_apparel); ?>			 	
				</select><span class="description"><?php _e('Обязательный элемент для Одежды, обуви, аксессуаров', 'xfavi'); ?> <strong>Apparel</strong>. <a href="//autoload.avito.ru/format/" target="_blank"><?php _e('Подробнее', 'xfavi'); ?></a></span>				
			</p>
			<p class="form-field _xfavi_appareltype">
				<label for="_xfavi_appareltype">ApparelType</label><select name="_xfavi_appareltype" id="_xfavi_appareltype" class="select short" >
				<?php $xfavi_apparel = esc_attr(get_post_meta($post->ID, '_xfavi_appareltype', 1)); ?>
				<option value="default" <?php selected($xfavi_apparel, 'default'); ?>><?php _e('По умолчанию', 'xfavi'); ?></option>
			 	<option value="disabled" <?php selected($xfavi_apparel, 'disabled'); ?>><?php _e('Отключено', 'xfavi'); ?></option>
				<?php echo xfavi_category_goods_type(4, $xfavi_apparel); ?>			 	
				</select><span class="description"><?php _e('Подтип товара (для верхней одежды)', 'xfavi'); ?> <strong>ApparelType</strong>. <a href="//autoload.avito.ru/format/" target="_blank"><?php _e('Подробнее', 'xfavi'); ?></a></span>
			</p>
			<?php do_action('xfavi_append_options_group', $post); ?>
		</div>
		<?php do_action('xfavi_after_options_group', $post); ?>
	</div>
	<?php
 } 

 public static function xfavi_art_woo_custom_fields_save($post_id) {
	// Сохранение текстового поля
	if (isset($_POST['_xfavi_condition'])) {update_post_meta($post_id, '_xfavi_condition', sanitize_text_field($_POST['_xfavi_condition']));}
	if (isset($_POST['_xfavi_custom'])) {update_post_meta($post_id, '_xfavi_custom', sanitize_text_field($_POST['_xfavi_custom']));}
 }  
 
 public static function xfavi_add_meta_product_cat($term) { ?>
	<tr class="form-field term-parent-wrap">
		<th scope="row" valign="top"><label><?php _e('Обрабатывать согласно правилам Авито', 'xfavi'); ?></label></th>
	 	<td>	   
			<select name="xfavi_cat_meta[xfavi_avito_standart]" id="xfavi_avito_standart">
			<?php $xfavi_avito_standart = esc_attr(get_term_meta($term->term_id, 'xfavi_avito_standart', 1)); ?>
				<option value="" <?php selected($xfavi_avito_standart, ''); ?> disabled="disabled"><?php _e('Не задано. Задайте', 'xfavi'); ?>!</option>			
				<option value="dom" <?php selected($xfavi_avito_standart, 'dom'); ?>><?php _e('Для дома и дачи', 'xfavi'); ?></option>
				<option value="tehnika" <?php selected($xfavi_avito_standart, 'tehnika'); ?>><?php _e('Бытовая электроника', 'xfavi'); ?></option>
				<option value="business" <?php selected($xfavi_avito_standart, 'business'); ?>><?php _e('Для бизнеса', 'xfavi'); ?></option>
				<option value="lichnye_veshi" <?php selected($xfavi_avito_standart, 'lichnye_veshi'); ?>><?php _e('Личные вещи', 'xfavi'); ?></option>
				<option value="zhivotnye" <?php selected($xfavi_avito_standart, 'zhivotnye'); ?>><?php _e('Животные', 'xfavi'); ?></option>
				<option value="zapchasti" <?php selected($xfavi_avito_standart, 'zapchasti'); ?>><?php _e('Запчасти и аксессуары', 'xfavi'); ?> (<?php _e('кроме', 'xfavi'); ?> "<?php _e('Шины, диски и колёса', 'xfavi'); ?>")</option>
				<option value="hobby" <?php selected($xfavi_avito_standart, 'hobby'); ?>><?php _e('Хобби и отдых', 'xfavi'); ?></option>
				</select><br /><label>AdType:</label><br />
			<select name="xfavi_cat_meta[xfavi_adType]" id="xfavi_adType">
			<?php $xfavi_adType = esc_attr(get_term_meta($term->term_id, 'xfavi_adType', 1)); ?>
				<option data-chained="zapchasti" value="Товар приобретен на продажу" <?php selected($xfavi_adType, 'Товар приобретен на продажу'); ?>><?php _e('Товар приобретен на продажу', 'xfavi'); ?></option>
				<option data-chained="zapchasti" value="Товар от производителя" <?php selected($xfavi_adType, 'Товар от производителя'); ?>><?php _e('Товар от производителя', 'xfavi'); ?></option>
				<option data-chained="hobby" value="Товар приобретен на продажу" <?php selected($xfavi_adType, 'Товар приобретен на продажу'); ?>><?php _e('Товар приобретен на продажу', 'xfavi'); ?></option>
				<option data-chained="hobby" value="Товар от производителя" <?php selected($xfavi_adType, 'Товар от производителя'); ?>><?php _e('Товар от производителя', 'xfavi'); ?></option>
				<option data-chained="tehnika" value="disabled" <?php selected($xfavi_adType, 'disabled'); ?>><?php _e('Отключено', 'xfavi'); ?></option>
				<option data-chained="zhivotnye" value="disabled" <?php selected($xfavi_adType, 'disabled'); ?>><?php _e('Отключено', 'xfavi'); ?></option>
				<option data-chained="business" value="disabled" <?php selected($xfavi_adType, 'disabled'); ?>><?php _e('Отключено', 'xfavi'); ?></option>
				<option data-chained="lichnye_veshi" value="Товар приобретен на продажу" <?php selected($xfavi_adType, 'Товар приобретен на продажу'); ?>><?php _e('Товар приобретен на продажу', 'xfavi'); ?></option>
				<option data-chained="lichnye_veshi" value="Товар от производителя" <?php selected($xfavi_adType, 'Товар от производителя'); ?>><?php _e('Товар от производителя', 'xfavi'); ?></option>
				<option data-chained="dom" value="Товар приобретен на продажу" <?php selected($xfavi_adType, 'Товар приобретен на продажу'); ?>><?php _e('Товар приобретен на продажу', 'xfavi'); ?></option>
				<option data-chained="dom" value="Товар от производителя" <?php selected($xfavi_adType, 'Товар от производителя'); ?>><?php _e('Товар от производителя', 'xfavi'); ?></option>
		   </select><br />
		   <p class="description"><?php _e('Укажите по каким правилам будут обрабатываться товары из данной категории', 'xfavi'); ?>. <a href="//autoload.avito.ru/format/" target="_blank"><?php _e('Подробнее', 'xfavi'); ?></a></p>
		</td>		
	</tr>
	<?php $result_arr = xfavi_option_construct($term); ?>
	<tr class="form-field term-parent-wrap">
		<th scope="row" valign="top"><label><?php _e('Авито', 'xfavi'); ?> Category</label></th>
		<td>
	   		<select name="xfavi_cat_meta[xfavi_avito_product_category]" id="xfavi_avito_product_category">
				<?php $xfavi_goods_type = esc_attr(get_post_meta($post->ID, '_xfavi_goods_type', 1)); ?>
				<option value="" <?php selected($xfavi_goods_type, ''); ?> disabled="disabled"><?php _e('Не задано. Задайте', 'xfavi'); ?>!</option>
				<?php echo $result_arr[0]; ?>
			</select><br />
			<p class="description"><?php _e('Обязательный элемент', 'xfavi'); ?> <strong>Category</strong>. <a href="//autoload.avito.ru/format/" target="_blank"><?php _e('Подробнее', 'xfavi'); ?></a><br /><strong><?php _e('Внимание', 'xfavi'); ?>!</strong> <?php _e('Если выпадающий список пуст, то сначала измените значение опции', 'xfavi'); ?> "<?php _e('Обрабатывать согласно правилам Авито', 'xfavi'); ?>". <?php _e('Укажите какой категори на Авито соответствует данная категория', 'xfavi'); ?>. </p>
		</td>
	</tr>
	<tr class="form-field term-parent-wrap">
		<th scope="row" valign="top"><label><?php _e('Авито', 'xfavi'); ?>:<br />- GoodsType<br />- Breed*<br />- TypeId**<br />- VehicleType***</label></th>
		<td>
	   		<select name="xfavi_cat_meta[xfavi_default_goods_type]" id="xfavi_default_goods_type">
				<option value="disabled"><?php _e('Отключено', 'xfavi'); ?></option>
	   			<?php echo $result_arr[1]; ?>
	   		</select><br />
			<p class="description"><?php _e('Элемент', 'xfavi'); ?> <strong>GoodsType</strong> / <strong>Breed</strong> / <strong>TypeId</strong> / <strong>VehicleType</strong>. <a href="//autoload.avito.ru/format/" target="_blank"><?php _e('Подробнее', 'xfavi'); ?></a><br />
			*Breed - <?php _e('Если Авито Category "Собаки" или "Кошки"', 'xfavi'); ?><br />
			**TypeId - <?php _e('Если Авито Category "Запчасти и аксессуары"', 'xfavi'); ?><br />
			***VehicleType  - <?php _e('Если Авито Category "Велосипеды"', 'xfavi'); ?>
			</p>
		</td>		
	</tr>
	<tr class="form-field term-parent-wrap">
		<th scope="row" valign="top"><label><?php _e('Авито', 'xfavi'); ?> GoodsSubType / ProductsType</label></label></th>
		<td>
	   		<select name="xfavi_cat_meta[xfavi_default_goods_subtype]" id="xfavi_default_goods_subtype">
				<option value="disabled"><?php _e('Отключено', 'xfavi'); ?></option>
	   			<?php echo $result_arr[2]; ?>
	   		</select><br />
			   <p class="description"><?php _e('Элемент', 'xfavi'); ?> <strong>GoodsSubType</strong> / <strong>ProductsType</strong>. <a href="//autoload.avito.ru/format/" target="_blank"><?php _e('Подробнее', 'xfavi'); ?></a></p>
		</td>		
	</tr>
	<tr class="form-field term-parent-wrap">
		<th scope="row" valign="top"><label><?php _e('Apparel', 'xfavi'); ?></label></th>
		<td>
			<select name="xfavi_cat_meta[xfavi_default_apparel]" id="xfavi_default_apparel">
			<?php $xfavi_default_apparel = esc_attr(get_term_meta($term->term_id, 'xfavi_default_apparel', 1)); ?>
				<option value="disabled" <?php selected($xfavi_default_apparel, 'disabled'); ?>><?php _e('Отключено', 'xfavi'); ?></option>
				<?php echo xfavi_category_goods_type(3, $xfavi_default_apparel); ?>
			</select><br />
			<p class="description"><?php _e('Обязательный элемент для Одежды, обуви, аксессуаров', 'xfavi'); ?> <strong>Apparel</strong>. <a href="//autoload.avito.ru/format/" target="_blank"><?php _e('Подробнее', 'xfavi'); ?></a></p>
		</td>
	</tr>
	<tr class="form-field term-parent-wrap">
		<th scope="row" valign="top"><label><?php _e('ApparelType', 'xfavi'); ?></label></th>
		<td>
			<select name="xfavi_cat_meta[xfavi_default_appareltype]" id="xfavi_default_appareltype">
			<?php $xfavi_default_appareltype = esc_attr(get_term_meta($term->term_id, 'xfavi_default_appareltype', 1)); ?>
				<option value="disabled" <?php selected($xfavi_default_appareltype, 'disabled'); ?>><?php _e('Отключено', 'xfavi'); ?></option>
				<?php echo xfavi_category_goods_type(4, $xfavi_default_appareltype); ?>
			</select><br />
			<p class="description"><?php _e('Подтип товара (для верхней одежды)', 'xfavi'); ?> <strong>ApparelType</strong>. <a href="//autoload.avito.ru/format/" target="_blank"><?php _e('Подробнее', 'xfavi'); ?></a></p>
		</td>		
	</tr>
	<script type="text/javascript">jQuery(document).ready(function() {
		/* https://github.com/tuupola/jquery_chained or $("#series").chainedTo("#mark"); */
		jQuery("#xfavi_adType").chained("#xfavi_avito_standart");
		jQuery("#xfavi_avito_product_category").chained("#xfavi_avito_standart"); 
		jQuery("#xfavi_default_goods_type").chained("#xfavi_avito_product_category");
		jQuery("#xfavi_default_goods_subtype").chained("#xfavi_default_goods_type"); 		
	});</script>  	
   <?php 
 } 
	/* Сохранение данных в БД */
	function xfavi_save_meta_product_cat($term_id){
		if (!isset($_POST['xfavi_cat_meta'])) {return;}
		$xfavi_cat_meta = array_map('sanitize_text_field', $_POST['xfavi_cat_meta']);
		foreach($xfavi_cat_meta as $key => $value) {
			if (empty($value)) {
				delete_term_meta($term_id, $key);
				continue;
			}
			update_term_meta($term_id, $key, $value);
		}
		return $term_id;
	} 
 
	// Вывод различных notices
	public function xfavi_admin_notices_function() {
		$xfavi_disable_notices = xfavi_optionGET('xfavi_disable_notices');
		if ($xfavi_disable_notices !== 'on') {
			$xfavi_settings_arr = xfavi_optionGET('xfavi_settings_arr');

	//		echo get_array_as_string($xfavi_settings_arr, '<br/>');

			$xfavi_settings_arr_keys_arr = array_keys($xfavi_settings_arr);
			for ($i = 0; $i < count($xfavi_settings_arr_keys_arr); $i++) {
				$feed_id = $xfavi_settings_arr_keys_arr[$i];
				$status_sborki = xfavi_optionGET('xfavi_status_sborki', $feed_id);
	//			$status_sborki = get_option('xfavi_status_sborki');
	//			var_dump($status_sborki);
				if ($status_sborki == false) {
					continue;
				} else {
					$status_sborki = (int)$status_sborki;
				}		
				if ($status_sborki !== -1) {	
					$count_posts = wp_count_posts('product');
					$vsegotovarov = $count_posts->publish;
					$step_export = (int)xfavi_optionGET('xfavi_step_export', $feed_id, 'set_arr');
					if ($step_export === 0) {$step_export = 500;}
					$vobrabotke = $status_sborki-$step_export;
					if ($vsegotovarov > $vobrabotke) {
						$vyvod = 'FEED № '.$feed_id.' '. __('Прогресс', 'xfavi').': '.$vobrabotke.' '. __('из', 'xfavi').' '.$vsegotovarov.' '. __('товаров', 'xfavi') .'.<br />'.__('Если индикаторы прогресса не изменились в течение 20 минут, попробуйте уменьшить "Шаг экспорта" в настройках плагина', 'xfavi');
					} else {
						$vyvod = 'FEED № '.$feed_id.' '. __('До завершения менее 70 секунд', 'xfavi');
					}	
					print '<div class="updated notice notice-success is-dismissible"><p>'. __('Идет автоматическое создание файла. XML-фид в скором времени будет создан', 'xfavi').'. '.$vyvod.'.</p></div>';
				}
			}
		}

		if (!class_exists('WooCommerce')) {
			print '<div class="notice error is-dismissible"><p>'. __('Для работы требуется плагин WooCommerce', 'xfavi'). '!</p></div>';
		}
 
	  
	if (isset($_REQUEST['xfavi_submit_action'])) {
		$run_text = '';
		if (sanitize_text_field($_POST['xfavi_run_cron']) !== 'off') {
			$run_text = '. '. __('Создание XML-фида запущено. Вы можете продолжить работу с сайтом', 'xfavi');
		}
		print '<div class="updated notice notice-success is-dismissible"><p>'. __('Обновлено', 'xfavi'). $run_text .'.</p></div>';
	}

	if (isset($_REQUEST['xfavi_submit_debug_page'])) {
		print '<div class="updated notice notice-success is-dismissible"><p>'. __('Обновлено', 'xfavi'). '.</p></div>';
	}

	if (isset($_REQUEST['xfavi_submit_clear_logs'])) {
		$upload_dir = (object)wp_get_upload_dir();
		$name_dir = $upload_dir->basedir."/xml-for-avito";
		$filename = $name_dir.'/xml-for-avito.log';
		$res = unlink($filename);
		if ($res == true) {
			print '<div class="notice notice-success is-dismissible"><p>' .__('Логи были очищены', 'xfavi'). '.</p></div>';					
		} else {
			print '<div class="notice notice-warning is-dismissible"><p>' .__('Ошибка доступа к log-файлу. Возможно log-файл был удален ранее', 'xfavi'). '.</p></div>';		
		}
	}

	/* сброс настроек */
	if (isset($_REQUEST['xfavi_submit_reset'])) {
		if (!empty($_POST) && check_admin_referer('xfavi_nonce_action_reset', 'xfavi_nonce_field_reset')) {
			$this->on_uninstall();
			$this->on_activation();	
			do_action('xfavi_submit_reset');
			print '<div class="updated notice notice-success is-dismissible"><p>'. __('Настройки были сброшены', 'xfavi'). '.</p></div>';			
		}
	} /* end сброс настроек */

	/* отправка отчёта */
	if (isset($_REQUEST['xfavi_submit_send_stat'])) {
		if (!empty($_POST) && check_admin_referer('xfavi_nonce_action_send_stat', 'xfavi_nonce_field_send_stat')) { 	
			if (is_multisite()) { 
				$xfavi_is_multisite = 'включен';	
				$xfavi_keeplogs = get_blog_option(get_current_blog_id(), 'xfavi_keeplogs');
			} else {
				$xfavi_is_multisite = 'отключен'; 
				$xfavi_keeplogs = get_option('xfavi_keeplogs');
			}

			$mail_content = "Версия плагина: ". xfavi_VER . PHP_EOL;
			$mail_content .= "Версия WP: ".get_bloginfo('version'). PHP_EOL;	 
			$woo_version = xfavi_get_woo_version_number();
			$mail_content .= "Версия WC: ".$woo_version. PHP_EOL;	
			$mail_content .= "Версия PHP: ".phpversion(). PHP_EOL;  
			$mail_content .= "Режим мультисайта: ".$xfavi_is_multisite. PHP_EOL;
			$mail_content .= "Вести логи: ".$xfavi_keeplogs. PHP_EOL;
			$mail_content .= "Расположение логов: ". xfavi_UPLOAD_DIR .'/xfavi.log'. PHP_EOL;
			$possible_problems_arr = xfavi_possible_problems_list();
			if ($possible_problems_arr[1] > 0) {
				$possible_problems_arr[3] = str_replace('<br/>', PHP_EOL, $possible_problems_arr[3]);
				$mail_content .= "Самодиагностика: ". PHP_EOL .$possible_problems_arr[3];
			} else {
				$mail_content .= "Самодиагностика: Функции самодиагностики не выявили потенциальных проблем". PHP_EOL;
			}  
			if (!class_exists('XmlforAvitoPro')) {$mail_content .= "Pro: не активна". PHP_EOL;} else {if (!defined('xfavip_VER')) {define('xfavip_VER', 'н/д');} $mail_content .= "Pro: активна (v ".xfavip_VER.")". PHP_EOL;}
			if (isset($_REQUEST['xfavi_its_ok'])) {
				$mail_content .= PHP_EOL ."Помог ли плагин: ".sanitize_text_field($_REQUEST['xfavi_its_ok']);
			}
			if (isset($_POST['xfavi_email'])) {
				$mail_content .= PHP_EOL ."Почта: ".sanitize_text_field($_POST['xfavi_email']);
			}
			if (isset($_POST['xfavi_message'])) {
				$mail_content .= PHP_EOL ."Сообщение: ".sanitize_text_field($_POST['xfavi_message']);
			}
			$argsp = array('post_type' => 'product', 'post_status' => 'publish', 'posts_per_page' => -1 );
			$products = new WP_Query($argsp);
			$vsegotovarov = $products->found_posts;
			$mail_content .= PHP_EOL ."Число товаров на выгрузку: ". $vsegotovarov;
			$xfavi_settings_arr = xfavi_optionGET('xfavi_settings_arr');
			$xfavi_settings_arr_keys_arr = array_keys($xfavi_settings_arr);
			for ($i = 0; $i < count($xfavi_settings_arr_keys_arr); $i++) {
				$status_sborki = (int)xfavi_optionGET('xfavi_status_sborki', $feed_id);
				$xfavi_file_url = urldecode(xfavi_optionGET('xfavi_file_url', $feed_id, 'set_arr'));
				$xfavi_file_file = urldecode(xfavi_optionGET('xfavi_file_file', $feed_id, 'set_arr'));
				$xfavi_whot_export = xfavi_optionGET('xfavi_whot_export', $feed_id, 'set_arr');
				$xfavi_status_cron = xfavi_optionGET('xfavi_status_cron', $feed_id, 'set_arr');
				$xfavi_ufup = xfavi_optionGET('xfavi_ufup', $feed_id, 'set_arr');	
				$xfavi_date_sborki = xfavi_optionGET('xfavi_date_sborki', $feed_id, 'set_arr');
				$xfavi_main_product = xfavi_optionGET('xfavi_main_product', $feed_id, 'set_arr');
				$xfavi_errors = xfavi_optionGET('xfavi_errors', $feed_id, 'set_arr');
	
				$mail_content .= PHP_EOL."ФИД №: ".$i. PHP_EOL . PHP_EOL;
				$mail_content .= "status_sborki: ".$status_sborki. PHP_EOL;
				$mail_content .= "УРЛ: ".get_site_url(). PHP_EOL;
				$mail_content .= "УРЛ XML-фида: ".$xfavi_file_url . PHP_EOL;
				$mail_content .= "Временный файл: ".$xfavi_file_file. PHP_EOL;
				$mail_content .= "Что экспортировать: ".$xfavi_whot_export. PHP_EOL;
				$mail_content .= "Автоматическое создание файла: ".$xfavi_status_cron. PHP_EOL;
				$mail_content .= "Обновить фид при обновлении карточки товара: ".$xfavi_ufup. PHP_EOL;
				$mail_content .= "Дата последней сборки XML: ".$xfavi_date_sborki. PHP_EOL;
				$mail_content .= "Что продаёт: ".$xfavi_main_product. PHP_EOL;
				$mail_content .= "Ошибки: ".$xfavi_errors. PHP_EOL;
			}
			wp_mail('support@icopydoc.ru', 'Отчёт XML for Avito', $mail_content);
			print '<div class="updated notice notice-success is-dismissible"><p>'. __('Данные были отправлены. Спасибо', 'xfavi'). '.</p></div>';						
		} 
	} /* end отправка отчёта */ 	
 }	

 	// Вывод различных notices
	public function print_admin_notices_func() {
		if (is_plugin_active('w3-total-cache/w3-total-cache.php')) {
			// global $pagenow; https://wpincode.com/kak-dobavit-sobstvennye-uvedomleniya-v-adminke-wordpress/
			if (isset($_GET['page'])) {
				if ($_GET['page'] === 'xfavidebug' || $_GET['page'] === 'xfaviexport') {
					print '<div class="notice notice-warning"><p><span class="xfavi_bold">W3 Total Cache</span> '. __('плагин активен', 'xfavi'). '. '. __('Если XML фид не создается, пожалуйста', 'xfavi'). ' <a href="https://icopydoc.ru/w3tc-page-cache-meshaet-sozdaniyu-fida-reshenie/?utm_source=xml-for-avito&utm_medium=organic&utm_campaign=in-plugin-xml-for-avito&utm_content=notice&utm_term=w3-total-cache" target="_blank">'. __('прочтите это руководство', 'xfavi') .'</a>.</p></div>';
				}
			}
		}

		/* Этот код потеницально будет исопльзоваться при полном переходе на ядро и классы

		$xfavi_disable_notices = xfavi_optionGET('xfavi_disable_notices');
		if ($xfavi_disable_notices !== 'on') {
			$xfavi_settings_arr = xfavi_optionGET('xfavi_settings_arr');
			$xfavi_settings_arr_keys_arr = array_keys($xfavi_settings_arr);
			for ($i = 0; $i < count($xfavi_settings_arr_keys_arr); $i++) {
				$feed_id = $xfavi_settings_arr_keys_arr[$i];
				$status_sborki = xfavi_optionGET('xfavi_status_sborki', $feed_id);
				if ($status_sborki == false) {
					continue;
				} else {
					$status_sborki = (int)$status_sborki;
				}		
				if ($status_sborki !== -1) {	
					$count_posts = wp_count_posts('product');
					$vsegotovarov = $count_posts->publish;
					$step_export = (int)xfavi_optionGET('xfavi_step_export', $feed_id, 'set_arr');
					if ($step_export === 0) {$step_export = 500;}
//					$vobrabotke = $status_sborki-$step_export;

					$vobrabotke = (($status_sborki - 1)  * $step_export) - $step_export;

					if ($vsegotovarov > $vobrabotke) { 
						if ($status_sborki == 1) {
							$vyvod = '<br />FEED № '.$feed_id.' '. __('Импорт списка категорий', 'xfavi'). '.<br />'.__('Если индикаторы прогресса не изменились в течение 20 минут, попробуйте уменьшить "Шаг экспорта" в настройках плагина', 'xfavi').'. '.__('Также убедитесь, что на вашем сайте нет проблем с CRON', 'xfavi').' (<a href="https://icopydoc.ru/minimalnye-trebovaniya-dlya-raboty-yml-for-yandex-market/?utm_source=xml-for-avito&utm_medium=organic&utm_campaign=in-plugin-xml-for-avito&utm_content=notice&utm_term=check_problems_cron" target="_blank">'. __('прочтите это руководство', 'xfavi') .'</a>)';
						}
						if ($status_sborki == 2) {
							$vyvod = '<br />FEED № '.$feed_id.' '. __('Подсчет количества товаров', 'xfavi');
						}
						if ($status_sborki > 2) {
							$vyvod = '<br />FEED № '.$feed_id.' '. __('Прогресс', 'xfavi').': '.$vobrabotke.' '. __('из', 'xfavi').' '.$vsegotovarov.' '. __('товаров', 'xfavi') .'.<br />'.__('Если индикаторы прогресса не изменились в течение 20 минут, попробуйте уменьшить "Шаг экспорта" в настройках плагина', 'xfavi').'. '.__('Также убедитесь, что на вашем сайте нет проблем с CRON', 'xfavi').' (<a href="https://icopydoc.ru/minimalnye-trebovaniya-dlya-raboty-yml-for-yandex-market/?utm_source=xml-for-avito&utm_medium=organic&utm_campaign=in-plugin-xml-for-avito&utm_content=notice&utm_term=check_problems_cron" target="_blank">'. __('прочтите это руководство', 'xfavi') .'</a>)';
						}
					} else {
						$vyvod = '<br />FEED № '.$feed_id.' '. __('До завершения менее 70 секунд', 'xfavi');
					}	
					print '<div class="updated notice notice-success is-dismissible"><p><span class="xfavi_bold">XML4AVITO:</span> '. __('Идет автоматическое создание файла. XML-фид в скором времени будет создан', 'xfavi').$vyvod.'.</p></div>';
				}
			}
		}
		/* */
	}
 
 // сборка
 public static function xfavi_construct_xml($feed_id = '1') {
	new XFAVI_Error_Log('FEED № '.$feed_id.'; Стартовала xfavi_construct_xml. Файл: xml-for-avito.php; Строка: '.__LINE__ , 0);

 	$result_xml = '';
	$status_sborki = (int)xfavi_optionGET('xfavi_status_sborki', $feed_id);
  
	// файл уже собран. На всякий случай отключим крон сборки
	if ($status_sborki == -1 ) {wp_clear_scheduled_hook('xfavi_cron_sborki', array($feed_id)); return;}
		  
	$xfavi_date_save_set = xfavi_optionGET('xfavi_date_save_set', $feed_id, 'set_arr');
	if ($xfavi_date_save_set == '') {
		$unixtime = current_time('timestamp', 1); // 1335808087 - временная зона GMT(Unix формат)
		xfavi_optionUPD('xfavi_date_save_set', $unixtime, $feed_id, 'yes', 'set_arr');
	}
	$xfavi_date_sborki = xfavi_optionGET('xfavi_date_sborki', $feed_id, 'set_arr');
	  
	if ($feed_id === '1') {$prefFeed = '';} else {$prefFeed = $feed_id;}	  
	if (is_multisite()) {
		/*
		* wp_get_upload_dir();
		* 'path'    => '/home/site.ru/public_html/wp-content/uploads/2016/04',
		* 'url'     => 'http://site.ru/wp-content/uploads/2016/04',
		* 'subdir'  => '/2016/04',
		* 'basedir' => '/home/site.ru/public_html/wp-content/uploads',
		* 'baseurl' => 'http://site.ru/wp-content/uploads',
		* 'error'   => false,
		*/
		$upload_dir = (object)wp_get_upload_dir();
		$filenamefeed = $upload_dir->basedir."/xml-for-avito/".$prefFeed."feed-avito-".get_current_blog_id().".xml";		
	} else {
		$upload_dir = (object)wp_get_upload_dir();
		$filenamefeed = $upload_dir->basedir."/xml-for-avito/".$prefFeed."feed-avito-0.xml";
	}
	if (file_exists($filenamefeed)) {		
		new XFAVI_Error_Log('FEED № '.$feed_id.'; Файл с фидом '.$filenamefeed.' есть. Файл: xml-for-avito.php; Строка: '.__LINE__ , 0);
		// return; // файла с фидом нет
		clearstatcache(); // очищаем кэш дат файлов
		$last_upd_file = filemtime($filenamefeed);
		new XFAVI_Error_Log('FEED № '.$feed_id.'; $xfavi_date_save_set='.$xfavi_date_save_set.'; $filenamefeed='.$filenamefeed, 0);
		new XFAVI_Error_Log('FEED № '.$feed_id.'; Начинаем сравнивать даты! Файл: xml-for-avito.php; Строка: '.__LINE__);	
		if ($xfavi_date_save_set < $last_upd_file) {
			new XFAVI_Error_Log('FEED № '.$feed_id.'; NOTICE: Нужно лишь обновить цены во всём фиде! Файл: xml-for-avito.php; Строка: '.__LINE__);
			xfavi_clear_file_ids_in_xml($feed_id); /* С версии 3.1.0 */
			xfavi_onlygluing($feed_id);
			return;
		}	
	}
	// далее исходим из того, что файла с фидом нет, либо нужна полная сборка
	  
	$step_export = (int)xfavi_optionGET('xfavi_step_export', $feed_id, 'set_arr');
	if ($step_export == 0) {$step_export = 500;}
	  
	if ($status_sborki == $step_export) { // начинаем сборку файла
		do_action('xfavi_before_construct', 'full'); // сборка стартовала
		$result_xml = xfavi_feed_header($feed_id);
		/* создаем файл или перезаписываем старый удалив содержимое */
		$result = xfavi_write_file($result_xml, 'w+', $feed_id);
		if ($result !== true) {
			new XFAVI_Error_Log('FEED № '.$feed_id.'; xfavi_write_file вернула ошибку! $result ='.$result.'; Файл: xml-for-avito.php; Строка: '.__LINE__);
			return; 
		} else {
			new XFAVI_Error_Log('FEED № '.$feed_id.'; xfavi_write_file отработала успешно; Файл: xml-for-avito.php; Строка: '.__LINE__);
		}
		xfavi_clear_file_ids_in_xml($feed_id); 
	} 
	if ($status_sborki > 1) {
		$result_xml	= '';
		$offset = $status_sborki-$step_export;
		$whot_export = xfavi_optionGET('xfavi_whot_export', $feed_id, 'set_arr');
		if ($whot_export === 'xfavi_vygruzhat') {
			$args = array(
				'post_type' => 'product',
				'post_status' => 'publish',
				'posts_per_page' => $step_export,
				'offset' => $offset,
				'relation' => 'AND',
				'meta_query' => array(
					array(
						'key' => '_xfavi_vygruzhat',
						'value' => 'yes'
					)
				)
			);			
		} else { // if ($whot_export == 'all' || $whot_export == 'simple')
			$args = array(
				'post_type' => 'product',
				'post_status' => 'publish',
				'posts_per_page' => $step_export, // сколько выводить товаров
				'offset' => $offset,
				'relation' => 'AND'
			);
		}

		$args = apply_filters('xfavi_query_arg_filter', $args, $feed_id);
		$featured_query = new WP_Query($args);
		$prod_id_arr = array(); 
		if ($featured_query->have_posts()) { 		
		 	for ($i = 0; $i < count($featured_query->posts); $i++) {
				// $prod_id_arr[] .= $featured_query->posts[$i]->ID;
				$prod_id_arr[$i]['ID'] = $featured_query->posts[$i]->ID;
				$prod_id_arr[$i]['post_modified_gmt'] =$featured_query->posts[$i]->post_modified_gmt;
		 	}
			wp_reset_query(); /* Remember to reset */
			unset($featured_query); // чутка освободим память
			xfavi_gluing($prod_id_arr, $feed_id);
			$status_sborki = $status_sborki + $step_export;
			new XFAVI_Error_Log('FEED № '.$feed_id.'; status_sborki увеличен на '.$step_export.' и равен '.$status_sborki.'; Файл: xml-for-avito.php; Строка: '.__LINE__);	  
			xfavi_optionUPD('xfavi_status_sborki', $status_sborki, $feed_id);		   
		} else {
			// если постов нет, пишем концовку файла
			new XFAVI_Error_Log('FEED № '.$feed_id.'; Постов больше нет, пишем концовку файла; Файл: xml-for-avito.php; Строка: '.__LINE__);
			$result_xml = apply_filters('xfavi_after_offers_filter', $result_xml, $feed_id);
			$result_xml .= "</Ads>";
			/* создаем файл или перезаписываем старый удалив содержимое */
			$result = xfavi_write_file($result_xml, 'a', $feed_id);
			new XFAVI_Error_Log('FEED № '.$feed_id.'; Файл фида готов. Осталось только переименовать временный файл в основной; Файл: xml-for-avito.php; Строка: '.__LINE__);
			xfavi_rename_file($feed_id);
			// выставляем статус сборки в "готово"
			$status_sborki = -1;
			if ($result === true) {
				xfavi_optionUPD('xfavi_status_sborki', $status_sborki, $feed_id);
				// останавливаем крон сборки
				wp_clear_scheduled_hook('xfavi_cron_sborki', array($feed_id));
				do_action('xfavi_after_construct', 'full'); // сборка закончена
				new XFAVI_Error_Log('FEED № '.$feed_id.'; SUCCESS: Сборка успешно завершена; Файл: xml-for-avito.php; Строка: '.__LINE__);
			} else {
				new XFAVI_Error_Log('FEED № '.$feed_id.'; ERROR: На завершающем этапе xfavi_write_file вернула ошибку! Я не смог записать концовку файла... $result ='.$result.'; Файл: xml-for-avito.php; Строка: '.__LINE__);
				do_action('xfavi_after_construct', 'false'); // сборка закончена
				return;
			}
		} // end if ($featured_query->have_posts())
	  } // end if ($status_sborki > 1)
   } // end public static function xfavi_construct_xml

	private function admin_notices_func($message, $class) {
		$xfavi_disable_notices = xfavi_optionGET('xfavi_disable_notices', 'set_arr');
		if ($xfavi_disable_notices === 'on') {
			return;
		} else {
			printf('<div class="notice %1$s"><p>%2$s</p></div>', $class, $message);
			return;
		}
	}

	private function save_post_meta($post_meta_arr, $post_id) {
		for ($i = 0; $i < count($post_meta_arr); $i++) {
			$meta_name = $post_meta_arr[$i];
			if (isset($_POST[$meta_name])) {
				update_post_meta($post_id, $meta_name, sanitize_text_field($_POST[$meta_name]));
			}
		}	
	}
} /* end class XmlforAvito */
?>